package com.icomsys.mapper;

import com.icomsys.vo.MessageSendLogInfo;
import com.icomsys.vo.MessageSendRequest;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
@Mapper
public interface MessageSendLogMapper {

    @Insert("INSERT INTO TB_UMS_SEND_LOG " +
            "(SEND_YN, USER_KEY, CALL_BACK, RECEIVER_TEL_NO, SEND_TYPE, CONTENTS, ADVERTISEMENT_YN, " +
            "IMAGE_FILE1, IMAGE_FILE2, IMAGE_FILE3, VIDEO_FILE, SENDER_KEY, TEMPLATE_CODE, INIT_CALL_NO, " +
            "API_RESPONSE_CODE, RESULT_CODE, REIGST_DATE, OPTION_YN) " +
            "VALUES (#{sendYn}, #{userKey}, #{callBack}, #{receiverTelNo}, #{sendType}, #{contents}, #{advertisementYn}, " +
            "#{imageFile1}, #{imageFile2}, #{imageFile3}, #{videoFile}, #{senderKey}, #{templateCode}, #{initCallNo}, " +
            "#{apiResponseCode}, #{resultCode}, #{registDate}, #{optionYn})")
    void insertSendLog(MessageSendLogInfo messageSendLogInfo);

    @Select("SELECT CALL_BACK, CONTENTS, RECEIVER_TEL_NO, USER_KEY, ADVERTISEMENT_YN, SEND_TYPE, SENDER_KEY, " +
            "TEMPLATE_CODE, IMAGE_FILE1, IMAGE_FILE2, IMAGE_FILE3, VIDEO_FILE, INIT_CALL_NO, OPTION_YN " +
            "FROM TB_UMS_SEND_LOG WHERE SEND_YN = 'N'")
    List<MessageSendRequest> selectSendLog();

    @Update("UPDATE TB_UMS_SEND_LOG SET SEND_YN = 'Y' WHERE USER_KEY = #{userKey}")
    void updateSendLog(int seq);
}